////////////////////////////////////////////////////////////////////////////////
//
// Copyright 2016 RWS Inc, All Rights Reserved
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of version 2 of the GNU General Public License as published by
// the Free Software Foundation
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
//
// This is the actual 3d engine.  It is resposible for triangle rendering with effects.
// It understands NOTHING of higher level structures -> that is controlled in 
// pipeline.h, which brings all the low level containers together into a
// low level engine
//

#ifndef RENDER_H
#define RENDER_H
//================================================== 
#include "Blue.h"
#ifdef PATHS_IN_INCLUDES
	#include "GREEN/BLiT/BLIT.H" // for rspLine


	#include "ORANGE/color/colormatch.h"
	#include "ORANGE/QuickMath/VectorMath.h"
	#include "ORANGE/QuickMath/FixedPoint.h"
#else
	#include "BLIT.H" // for rspLine	
	#include "colormatch.h"
	#include "vectormath.h"
	#include "fixedpoint.h"
#endif

typedef struct
{
	RFixedS32 x;
	RFixedS32 y;
	RFixedS32 z;
} RRenderPt32; // For internal use

#endif
